/**	
*	@file	SlideShow.java
*	@author	Callum Massey A6
*	@date	27/04/13
*	@see	GUI
*
*	@brief	Creates and runs the Slideshow.
*	
*	Slideshow creates a new thread then runs through each graph
*	
*/

import java.awt.Point;

import org.jdesktop.animation.timing.Animator;
import org.jdesktop.animation.timing.interpolation.PropertySetter;




public class SlideShow extends Thread {
	private GUI m_Host;
	
	
	void init() {
		
	}
	
	public SlideShow(GUI host){
		Set_m_Host(host);
	}
	
	/**
	 * @return the m_Host
	 */
	public GUI Get_m_Host() {
		return m_Host;
	}

	/**
	 * @param m_Host the m_Host to set
	 */
	public void Set_m_Host(GUI m_Host) {
		this.m_Host = m_Host;
	}
	private void transition() {
		Point origLocation = m_Host.GetM_ChartPanel().getLocation();
		
		Point destLocation = new Point(origLocation.x+900, origLocation.y);
		
		PropertySetter setter = new PropertySetter(m_Host.GetM_ChartPanel(), "location", origLocation, destLocation);
		
		Animator anim = new Animator(1000, setter);
		
		anim.start();
		Point origLocation2 = m_Host.GetM_ChartPanelBottom().getLocation();
		
		Point destLocation2 = new Point(origLocation2.x-900, origLocation2.y);
		
		PropertySetter setter2 = new PropertySetter(m_Host.GetM_ChartPanelBottom(), "location", origLocation2, destLocation2);
		
		Animator anim2 = new Animator(1000, setter2);
		
		anim2.start();
		try {
			sleep(1500);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	void pause() {
		while(m_Host.GetPaused()) {
			try {
				sleep(500);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	public void run(){
		while(m_Host.GetPaused() == false) {
			PieChart();
			try {
				sleep(m_Host.GetInterval());
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			pause();
			transition();
			
			AreaChart();
			try {
				sleep(m_Host.GetInterval());
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			pause();
			transition();
			Barchart();
			try {
				sleep(m_Host.GetInterval());
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			pause();
			transition();
			Histogram();
			try {
				sleep(m_Host.GetInterval());
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			pause();
			transition();
			StackedAreaChart();
			try {
				sleep(m_Host.GetInterval());
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			pause();
			transition();
			ScatterChart();
			try {
				sleep(m_Host.GetInterval());
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			pause();
			transition();
			LineChart();
			try {
				sleep(m_Host.GetInterval());
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			pause();
			transition();
			BarChart3D();
			try {
				sleep(m_Host.GetInterval());
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			pause();
			transition();
			PieChart3D();
			try {
				sleep(m_Host.GetInterval());
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			pause();
			transition();
			StackedBarChart();
			try {
				sleep(m_Host.GetInterval());
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			pause();
			transition();
			StackedBarChart3D();
			try {
				sleep(m_Host.GetInterval());
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			pause();
			transition();
			RingChart();
			try {
				sleep(m_Host.GetInterval());
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			pause();
			transition();
			MultiplePieChart();
			try {
				sleep(m_Host.GetInterval());
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			pause();
			transition();
			MultiplePieChart3D();
			try {
				sleep(m_Host.GetInterval());
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			pause();
			transition();
		}
	}
	
	void PieChart(){
		m_Host.SetChartOnPanel(new PieChart(
				   m_Host.GetSelectedTableData(),
				   "Pie Chart", m_Host.GetColourScheme(),
				   m_Host.GetUserDefinedScheme()));
		m_Host.SetChartOnPanelBottom(new PieChart(
				   m_Host.GetSelectedTableDataLeft(),
				   "Pie Chart", m_Host.GetColourScheme(),
				   m_Host.GetUserDefinedScheme()));
		m_Host.SetOptionsOnToolbar(false);
		m_Host.ClearSettings();
		m_Host.SetHostTitle(m_Host.GetChart().GetTitle());
	}
	void Histogram() {
		Get_m_Host().SetChartOnPanel(new HistogramChart(
				Get_m_Host().GetSelectedTableData(),
				"Histogram Chart",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new HistogramChart(
				Get_m_Host().GetSelectedTableDataLeft(),
				"Histogram Chart",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(true);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
		Get_m_Host().SetHostXAxis(Get_m_Host().GetChart().GetXAxis());
	}
	void Barchart() {
		Get_m_Host().SetChartOnPanel(new BarChart(
				Get_m_Host().GetSelectedTableData(),
				"Bar Chart", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new BarChart(
				Get_m_Host().GetSelectedTableDataLeft(),
				"Bar Chart", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(true);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
	}
	void StackedAreaChart() {
		Get_m_Host().SetChartOnPanel(new StackedAreaChart(
				Get_m_Host().GetSelectedTableData(),
				"Stacked Area Chart",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new StackedAreaChart(
				Get_m_Host().GetSelectedTableDataLeft(),
				"Stacked Area Chart",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(true);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
	}
	void ScatterChart() {
		Get_m_Host().SetChartOnPanel(new ScatterChart(
				   Get_m_Host().GetSelectedTableData(),
				   "Scatter Chart", Get_m_Host().GetColourScheme(),
				   Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new ScatterChart(
				   Get_m_Host().GetSelectedTableDataLeft(),
				   "Scatter Chart", Get_m_Host().GetColourScheme(),
				   Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(true);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
		Get_m_Host().SetHostXAxis(Get_m_Host().GetChart().GetXAxis());
		Get_m_Host().SetHostYAxis(Get_m_Host().GetChart().GetYAxis());
	}
	void LineChart() {
		Get_m_Host().SetChartOnPanel(new LineChart(
				Get_m_Host().GetSelectedTableData(),
				"Line Chart", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new LineChart(
				Get_m_Host().GetSelectedTableDataLeft(),
				"Line Chart", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(true);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
	}
	void BarChart3D() {
		Get_m_Host().SetChartOnPanel(new BarChart3D(
				Get_m_Host().GetSelectedTableData(),
				"Bar Chart 3D", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new BarChart3D(
				Get_m_Host().GetSelectedTableDataLeft(),
				"Bar Chart 3D", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(true);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
	}
	void PieChart3D() {
		Get_m_Host().SetChartOnPanel(new PieChart3D(
				Get_m_Host().GetSelectedTableData(),
				"Pie Chart 3D", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new PieChart3D(
				Get_m_Host().GetSelectedTableDataLeft(),
				"Pie Chart 3D", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(false);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
	}
	void lineChart3D() {
		Get_m_Host().SetChartOnPanel(new LineChart3D(
				Get_m_Host().GetSelectedTableData(),
				"Line Chart 3D",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new LineChart3D(
				Get_m_Host().GetSelectedTableDataLeft(),
				"Line Chart 3D",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(true);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
		Get_m_Host().closeChartDialog();
	}
	void StackedBarChart() {
		Get_m_Host().SetChartOnPanel(new StackedBarChart(
				Get_m_Host().GetSelectedTableData(),
				"Stacked Bar Chart",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new StackedBarChart(
				Get_m_Host().GetSelectedTableDataLeft(),
				"Stacked Bar Chart",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(true);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
	}
	void StackedBarChart3D() {
		Get_m_Host().SetChartOnPanel(new StackedBarChart3D(
				Get_m_Host().GetSelectedTableData(),
				"Stacked Bar Chart 3D",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new StackedBarChart3D(
				Get_m_Host().GetSelectedTableDataLeft(),
				"Stacked Bar Chart 3D",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(true);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
	}
	void RingChart() {
		Get_m_Host().SetChartOnPanel(new RingChart(
				Get_m_Host().GetSelectedTableData(),
				"Ring Chart", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new RingChart(
				Get_m_Host().GetSelectedTableDataLeft(),
				"Ring Chart", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(false);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
	}
	void AreaChart() {
		Get_m_Host().SetChartOnPanel(new AreaChart(
				Get_m_Host().GetSelectedTableData(),
				"Area Chart", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new AreaChart(
				Get_m_Host().GetSelectedTableDataLeft(),
				"Area Chart", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(true);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
	}
	void BubbleChart() {
		Get_m_Host().SetChartOnPanel(new BubbleChart(
				Get_m_Host().GetSelectedTableData(),
				"Bubble Chart", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new BubbleChart(
				Get_m_Host().GetSelectedTableDataLeft(),
				"Bubble Chart", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(true);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
		Get_m_Host().SetHostXAxis(Get_m_Host().GetChart().GetXAxis());
		Get_m_Host().SetHostYAxis(Get_m_Host().GetChart().GetYAxis());
	}
	void XYBarChart() {
		Get_m_Host().SetChartOnPanel(new XYBarChart(
				Get_m_Host().GetSelectedTableData(),
				"XY Bar Chart", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new XYBarChart(
				Get_m_Host().GetSelectedTableDataLeft(),
				"XY Bar Chart", Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(true);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
		Get_m_Host().SetHostXAxis(Get_m_Host().GetChart().GetXAxis());
		Get_m_Host().SetHostYAxis(Get_m_Host().GetChart().GetYAxis());
	}
	void XYLineChart() {
		Get_m_Host().SetChartOnPanel(new XYLineChart(
				Get_m_Host().GetSelectedTableData(),
				"XY Line Chart",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new XYLineChart(
				Get_m_Host().GetSelectedTableDataLeft(),
				"XY Line Chart",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(true);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
		Get_m_Host().SetHostXAxis(Get_m_Host().GetChart().GetXAxis());
		Get_m_Host().SetHostYAxis(Get_m_Host().GetChart().GetYAxis());
	}
	void MultiplePieChart() {
		Get_m_Host().SetChartOnPanel(new MultiplePieChart(
				Get_m_Host().GetSelectedTableData(),
				"Multiple Pie Chart",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new MultiplePieChart(
				Get_m_Host().GetSelectedTableDataLeft(),
				"Multiple Pie Chart",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(false);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
	}
	void MultiplePieChart3D() {
		Get_m_Host().SetChartOnPanel(new MultiplePieChart3D(
				Get_m_Host().GetSelectedTableData(),
				"Multiple Pie Chart 3D",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetChartOnPanelBottom(new MultiplePieChart3D(
				Get_m_Host().GetSelectedTableDataLeft(),
				"Multiple Pie Chart 3D",
				Get_m_Host().GetColourScheme(),
				Get_m_Host().GetUserDefinedScheme()));
		Get_m_Host().SetOptionsOnToolbar(false);
		Get_m_Host().ClearSettings();
		Get_m_Host().SetHostTitle(Get_m_Host().GetChart().GetTitle());
	}
}
